#include <SD.h>
#include <SPI.h>
#include <TMRpcm.h>
#include <SoftwareSerial.h>

#define enA 5
#define in1 8
#define in2 7
#define enB 3
#define in3 4
#define in4 2
#define led 12
#define SD_ChipSelectPin 10

int motorSpeedA=0;
int motorSpeedB=0;

TMRpcm tmrpcm;
SoftwareSerial BTSerial(0,1);

void setup() {
  BTSerial.begin(9600);
  tmrpcm.speakerPin=9;
  Serial.begin(9600);
  if(!SD.begin(SD_ChipSelectPin)){
    Serial.println("SD FAIL");
    return;
  }
  pinMode(enA, OUTPUT);
  pinMode(enB, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
  pinMode(led, OUTPUT);

  // play_music()
  tmrpcm.setVolume(5);
  if (SD.exists("music.wav")) {
    Serial.println("music.wav exists!");
    tmrpcm.play("music.wav");
  } else {
    Serial.println("music.wav does not exist!");
  }
}

void loop() {
  
  if(BTSerial.available()>0){
    char data=(char)BTSerial.read();
    Serial.print(data);
        switch(data){
        // forward()
        case 'F':
          digitalWrite(in1, HIGH);
          digitalWrite(in2, LOW);

          digitalWrite(in3, HIGH);
          digitalWrite(in4, LOW);
          motorSpeedA=220;
          motorSpeedB=220;        
          break;
        case 'B':
        // backward()
          digitalWrite(in1, LOW);
          digitalWrite(in2, HIGH);

          digitalWrite(in3, LOW);
          digitalWrite(in4, HIGH);
          motorSpeedA=220;
          motorSpeedB=220;        
          break;
        case 'L':
        // left()
          digitalWrite(in1, HIGH);
          digitalWrite(in2, LOW);

          motorSpeedA=220;
          motorSpeedB=0;        
          break;
        case 'R':
        // right()
          digitalWrite(in3, HIGH);
          digitalWrite(in4, LOW);

          motorSpeedA=0;
          motorSpeedB=220;        
          break;
        case 'G':
        // forward_left()
          digitalWrite(in1, HIGH);
          digitalWrite(in2, LOW);

          digitalWrite(in3, HIGH);
          digitalWrite(in4, LOW);
          motorSpeedA=220;
          motorSpeedB=100;          
          break;
        case 'I':
        // forward_right()
          digitalWrite(in1, HIGH);
          digitalWrite(in2, LOW);

          digitalWrite(in3, HIGH);
          digitalWrite(in4, LOW);
          motorSpeedA=100;
          motorSpeedB=220;         
          break;
        case 'H':
        // backward_left()
          digitalWrite(in1, LOW);
          digitalWrite(in2, HIGH);

          digitalWrite(in3, LOW);
          digitalWrite(in4, HIGH);
          motorSpeedA=220;
          motorSpeedB=100;            
          break;
        case 'J':
        // backward_right()
          digitalWrite(in1, LOW);
          digitalWrite(in2, HIGH);

          digitalWrite(in3, LOW);
          digitalWrite(in4, HIGH);
          motorSpeedA=100;
          motorSpeedB=220;        
          break;
        // stop()
        case 'S':
          motorSpeedA=0;
          motorSpeedB=0;        
          break;
        default:
          motorSpeedA=0;
          motorSpeedB=0; 
          break;
      }
    analogWrite(enA, motorSpeedA);
    analogWrite(enB, motorSpeedB);
  }
}
